package ru.dbotthepony.mc.otm.triggers

import com.google.gson.JsonObject
import net.minecraft.advancements.critereon.AbstractCriterionTriggerInstance
import net.minecraft.advancements.critereon.DeserializationContext
import net.minecraft.advancements.critereon.EntityPredicate
import net.minecraft.advancements.critereon.SimpleCriterionTrigger
import net.minecraft.resources.ResourceLocation
import net.minecraft.server.level.ServerPlayer
import ru.dbotthepony.mc.otm.OverdriveThatMatters

object BecomeAndroidTrigger : SimpleCriterionTrigger<BecomeAndroidTrigger.Instance>() {
	val ID = ResourceLocation(OverdriveThatMatters.MOD_ID, "become_android")

	override fun getId(): ResourceLocation {
		return ID
	}

	override fun createInstance(
		p_66248_: JsonObject,
		p_66249_: EntityPredicate.Composite,
		p_66250_: DeserializationContext
	): Instance {
		return Instance
	}

	fun trigger(player: ServerPlayer) {
		trigger(player) { true }
	}

	object Instance : AbstractCriterionTriggerInstance(ID, EntityPredicate.Composite.ANY)
}

object BecomeAndroidSleepTrigger : SimpleCriterionTrigger<BecomeAndroidSleepTrigger.Instance>() {
	val ID = ResourceLocation(OverdriveThatMatters.MOD_ID, "become_android_sleep")

	override fun getId(): ResourceLocation {
		return ID
	}

	override fun createInstance(
		p_66248_: JsonObject,
		p_66249_: EntityPredicate.Composite,
		p_66250_: DeserializationContext
	): Instance {
		return Instance
	}

	fun trigger(player: ServerPlayer) {
		trigger(player) { true }
	}

	object Instance : AbstractCriterionTriggerInstance(ID, EntityPredicate.Composite.ANY)
}

object BecomeAndroidDeathTrigger : SimpleCriterionTrigger<BecomeAndroidDeathTrigger.Instance>() {
	val ID = ResourceLocation(OverdriveThatMatters.MOD_ID, "become_android_death")

	override fun getId(): ResourceLocation {
		return ID
	}

	override fun createInstance(
		p_66248_: JsonObject,
		p_66249_: EntityPredicate.Composite,
		p_66250_: DeserializationContext
	): Instance {
		return Instance
	}

	fun trigger(player: ServerPlayer) {
		trigger(player) { true }
	}

	object Instance : AbstractCriterionTriggerInstance(ID, EntityPredicate.Composite.ANY)
}

object BecomeHumaneTrigger : SimpleCriterionTrigger<BecomeHumaneTrigger.Instance>() {
	val ID = ResourceLocation(OverdriveThatMatters.MOD_ID, "become_humane")

	override fun getId(): ResourceLocation {
		return ID
	}

	override fun createInstance(
		p_66248_: JsonObject,
		p_66249_: EntityPredicate.Composite,
		p_66250_: DeserializationContext
	): Instance {
		return Instance
	}

	fun trigger(player: ServerPlayer) {
		trigger(player) { true }
	}

	object Instance : AbstractCriterionTriggerInstance(ID, EntityPredicate.Composite.ANY)
}
